from AutoRPE.UtilsRPE.Functions import load_vault, save_variable_list, load_variable_list
from optparse import OptionParser


def translate_vault(list1, path1, path2, print_id_not_found=False):
    vault01 = load_vault(path1)
    vault02 = load_vault(path2)
    list_of_equivalent_id = []
    list_of_jon_doe = []
    id_in_list = load_variable_list(list1)
    variables01 = [vault01.get_variable_by_id(id) for id in id_in_list]
    variables02 = [var for var in vault02.variables if var.id]
    for var01 in variables01:
        name01 = var01.name
        routine01 = var01.routine.name
        module01 = var01.routine.module.name
        var_found = False
        for var02 in variables02:
            id02 = var02.id
            name02 = var02.name
            routine02 = var02.routine.name
            module02 = var02.routine.module.name
            if name02 == name01 and routine02 == routine01 and module02 == module01:
                list_of_equivalent_id.append(id02)
                variables02.remove(var02)
                var_found = True
                break
        if not var_found and print_id_not_found:
            for var02 in variables02:
                id02 = var02.id
                name02 = var02.name
                if name02 == name01:
                    list_of_jon_doe.append(id02)

    save_variable_list(list_of_equivalent_id, 'equivalent_ids', vault02)
    if print_id_not_found:
        save_variable_list(list_of_jon_doe, 'ids_not_found', vault02)


if __name__ == "__main__":
    parser = OptionParser()
    parser.add_option("-i", "--list", dest="list1")
    parser.add_option("-o", "--origin-vault", dest="path1")
    parser.add_option("-d", "--destination-vault", dest="path2")
    parser.add_option("-v", "--verbose", dest="print_id_not_found", default=False, action="store_true",
                      help="print variables not found to list")
    (options, args) = parser.parse_args()

    list1 = options.list1
    path1 = options.path1
    path2 = options.path2

    if not list1 or not path1 or not path2:
        print("\nAll these arguments are mandatory\n")
        parser.print_help()
        exit(1)
    print_id_not_found = options.print_id_not_found

    translate_vault(list1, path1, path2, print_id_not_found)
